# -*- coding: utf-8 -*-
"""
Created on Wed Jul  5 09:51:18 2023

@author: becker07
"""

#!/usr/bin/env python
import os
import sys
import time
import datetime
import elabapi_python
from elabapi_python.rest import ApiException
import requests
import argparse
import json
import couchdb 
import numpy as np
from urllib3.exceptions import InsecureRequestWarning
from urllib3 import disable_warnings


couch = couchdb.Server('http://a73434.berlin.ptb.de:5984')
db = couch['vl_db'] # existing

config_file = "config.json"
with open(config_file) as fp:
	config = json.load(fp)

cmd_parser = argparse.ArgumentParser(description= "Schreibt erstellen kalibrierschein (TeX und PDF) in die CouchDB")
cmd_parser.add_argument("cal_no", type= str, metavar= "<Kalibrierschein-Nummer>", nargs= "*")
cmd_parser.add_argument("-e", "--elab", type= int, metavar= "<eLab ID>")
args = cmd_parser.parse_args()

if args.elab is not None:
	elab_id = str(args.elab)

cers = [""] * len(args.cal_no)
print(args.cal_no)

for pos in range(len(args.cal_no)):
	cers[pos] = str(args.cal_no[pos])
print(cers)

#########################
#         CONFIG        #
#########################
API_HOST_URL = 'https://elabftw.ptb.de/api/v2'
# replace with your api key
API_KEY = '14-aa825b23d9b910a1e9c1e5d52713b1ec191158ec06daaf0ecad6148a948dd3608c4d3dbc18c7212ba15114'
# number of days to look back

#########################
#      END CONFIG       #
#########################

# Configure the api client
configuration = elabapi_python.Configuration()
configuration.api_key['api_key'] = API_KEY
configuration.api_key_prefix['api_key'] = 'Authorization'
configuration.host = API_HOST_URL
configuration.debug = False
configuration.verify_ssl = True

# create an instance of the API class
api_client = elabapi_python.ApiClient(configuration)
# fix issue with Authorization header not being properly set by the generated lib
api_client.set_default_header(header_name='Authorization', header_value=API_KEY)

# create an instance of Experiments 
experimentsApi = elabapi_python.ExperimentsApi(api_client)
uploadsApi = elabapi_python.UploadsApi(api_client)

# create an instance of Tags 
api_instance = elabapi_python.TagsApi(api_client)

# calculate the date
today = datetime.date.today()

########  

#elab_id=648
#cers = ["75586_0001"]    #  Beispiel: cers = ["75511_0001","75512_0001"] 
TL1_2= "auto"  #### FM1 oder TLA, "auto" versucht, ein passendes Dokument zu finden

year = str(config["KS-Daten"]["Jahr"])
kk= "KK" 
commentar = ''

################################


# get experiment with ID xxxx
exp = experimentsApi.get_experiment(elab_id)
print('='*72)
print('\n ******** Experiment {} (Original): \n'.format(elab_id), exp)
print('\n ******** Experiment-Body ', exp.body)
print('\n ******** Experiment-Tags ', exp.userid)
print('='*72)




#################################

if kk == "KK":
    type_k = "-kk-"
    tag_type = "KK"

#################################

db_teststring = {"TLA": "cal-" + year + "-tl2" + type_k + cers[0], "TLV": "cal-" + year + "-fm1" + type_k + cers[0]}
match TL1_2:
    case "" | "auto":
        TL1_2 = ""
        for test in db_teststring.keys():
            db_result = db.get(db_teststring[test])
            if db_result is not None:
                TL1_2 = TL1_2 + test
print("TL1_2:", TL1_2)
match TL1_2:
    case "TLA" | "TL2":
        tl="-tl2"
        json_file = db_teststring["TLA"]
        print(json_file)
        doc = db.get(json_file)
        STD1 ="TLA"
        STD2 ="TL2"
        tab_begin=' </p><table style="border-collapse:collapse;width:100%;height:100%;"><tr style="height:16px;"><td style="width:33.3222%;height:16px;">DB-Link</td><td style="width:33.3222%;height:16px;">p-upstream</td><td style="width:33.3222%;height:16px;">Gas</td></tr>'

    case "TLV" | "FM1":
        tl="-fm1"
        json_file = db_teststring["TLV"]
        print(json_file)
        doc = db.get(json_file)
        STD1 ="TLV"
        STD2 ="FM1"
        tab_begin=' </p><table style="border-collapse:collapse;width:100%;height:100%;"><tr style="height:16px;"><td style="width:33.3222%;height:16px;">DB-Link</td><td style="width:33.3222%;height:16px;">Ventil</td><td style="width:33.3222%;height:16px;">Gas</td></tr>'
    case _:
        print(TL1_2, "ist keine gültige Messung!")
        sys.exit(0)

#if TL1_2 == "TLA":
#    #tl="-tl2"
#    json_file = "cal-" + year + tl + type_k + cers[0] 
#    print(json_file)
#    doc = db.get(json_file)
#    STD1 ="TLA"
#    STD2 ="TL2"
#    tab_begin=' </p><table style="border-collapse:collapse;width:100%;height:100%;"><tr style="height:16px;"><td style="width:33.3222%;height:16px;">DB-Link</td><td style="width:33.3222%;height:16px;">p-upstream</td><td style="width:33.3222%;height:16px;">Gas</td></tr>'
    
#else :
#    #tl="-fm1"
#    json_file = "cal-" + year + tl + type_k + cers[0] 
#    print(json_file)
#    doc = db.get(json_file)
#    Type_k =(doc["Calibration"]["Type"])
#    STD1 ="TLV"
#    STD2 ="FM1"
#    tab_begin=' </p><table style="border-collapse:collapse;width:100%;height:100%;"><tr style="height:16px;"><td style="width:33.3222%;height:16px;">DB-Link</td><td style="width:33.3222%;height:16px;">Ventil</td><td style="width:33.3222%;height:16px;">Gas</td></tr>'


# Die Überschrift wird zusammengesetzt 
title1=doc["Calibration"]["Customer"]["Sign"]
body_title = STD1 + ' / ' + STD2  +  ' Kalibrierung [' + title1 + ']'


# Die Tabelle wird zusammengesetzt 
body_begin='<p> '
#tab_begin=' </p><table style="border-collapse:collapse;width:100%;height:100%;"><tr style="height:16px;"><td style="width:33.3222%;height:16px;">DB-Link</td><td style="width:33.3222%;height:16px;">p-upstream</td><td style="width:33.3222%;height:16px;">Gas</td></tr>'
text1='<tr style="height:16px;"><td style="width:33.3222%;height:16px;"><a href="http://a73434.berlin.ptb.de:5984/_utils/#database/vl_db/'
text1_1='tl2'
text1_2='-'
text1_3='kk'
text1_4='-'
text2='" target="_blank" rel="noreferrer noopener">cal-'
text3='</a></td><td style="width:33.3222%;height:16px;">'
text4='</td><td style="width:33.3222%;height:16px;">'
text5='</td></tr>'
tab_end='</table><p> </p><p> </p>'



# Die Tags werden zusammengesetzt 
json_file_tag = "cal-" + year + tl + type_k + cers[0] 
doc_tag = db.get(json_file_tag)
ReferenceNo =doc_tag["Calibration"]["Presettings"]["CommonReferenceNo"]
print('stopp')

Type_k =(doc_tag["Calibration"]["Type"])
print(Type_k)
CustomerSign =(doc_tag["Calibration"]["Customer"]["Sign"])



len_cers=len(cers)

val = ""
size = len_cers
tab_body = [val] * size
p_up = [val] * size
gas = [val] * size
vent = [val] * size
print('111111111', tab_body)    


if TL1_2 == 'TLA':

    i = 0
    while i < len(cers):
        json_file = "cal-" + year + tl + type_k + cers[i] 
        print(json_file)
        doc = db.get(json_file)
        p_up[i]=str(doc["Calibration"]["Result"]["Formula"]["PressureUpstream"])
        gas[i]=doc["Calibration"]["ToDo"]["Gas"]
        body=text1 + json_file + text2+  year +tl + type_k + cers[i]+ text3 + p_up[i] + text4 +  gas[i] + text5
        tab_body[i] = body
        p_up[i]=np.array(doc["Calibration"]["Result"]["Formula"]["PressureUpstream"])
        
        
        i += 1
else :
    i = 0
    while i < len(cers):
        json_file = "cal-" + year + tl + type_k + cers[i] 
        print(json_file)
        x = cers[i][:5]
        doc = db.get(json_file)
        name_plot= "Scan_" + x + ".pdf"
        file_plot= name_plot
        name_Scan_json= "Scan" + x + ".pdf"
        file_json= name_Scan_json
        attachment = db.get_attachment(doc, "Scan.pdf").read()
        with open(file_json, 'wb') as pdf_object:
            pdf_object.write(attachment)
        uploadsApi.post_upload('experiments', elab_id, file=file_json, comment='Plot: Signal und Offset vom Leck')
        os.remove(file_json)
        gas[i]=doc["Calibration"]["ToDo"]["Gas"]
        vent[i]=doc["Calibration"]["Result"]["Formula"]["Valve"]
        body=text1 + json_file + text2 + year + tl + type_k + cers[i]+ text3 + vent[i] + text4 +  gas[i] + text5
        tab_body[i] = body
        i += 1

    
text_all= ''.join(tab_body)

body_tab=body_begin + commentar + tab_begin + text_all + tab_end


now = datetime.datetime.now()

#new_body='<p>Neu von UteXX x({})</p>'.format(now.strftime('%Y-%m-%d %H:%M:%S'))


data_body = { 'body': body_tab}
data_title = {'title': body_title}


print('elab_id= ', elab_id)

# === Modifizieren der Einträge (hier Eintrag "body") ===
response_body = experimentsApi.patch_experiment(elab_id, body=data_body)
response_title = experimentsApi.patch_experiment(elab_id, body=data_title)
data_tag={ 'tag': ReferenceNo}
response_tag = api_instance.post_tag('experiments', elab_id, body=data_tag)
data_tag={ 'tag': Type_k}
response_tag = api_instance.post_tag('experiments', elab_id, body=data_tag)
data_tag={ 'tag': STD1}
response_tag = api_instance.post_tag('experiments', elab_id, body=data_tag)
data_tag={ 'tag': STD2}
response_tag = api_instance.post_tag('experiments', elab_id, body=data_tag)
data_tag={ 'tag': CustomerSign}
response_tag = api_instance.post_tag('experiments', elab_id, body=data_tag)
#response = experimentsApi.patch_experiment(elab_id, tags=new_tags)
print('='*72)
# === der modifizierte Zustand ===
print('\n******** Experiment {} (modifiziert): \n'.format(elab_id), response_body)
print('='*72)






