import json
import time
import numpy as np
import socket

totalChannels = 0
#totalChannels = 20

def reset():
    send_message("*rst", False)
    #send_message("*idn?", True)
    
def send_message(message, reply):
    print("message:", message)
    #s = socket.socket()
    #s.setblocking(True)
    #s.settimeout(5)
    #s.connect(s.gethostbyname(DAQ_hostname), DAQ_port)
    message = message + "\n"
    s = socket.create_connection((DAQ_hostname, DAQ_port), timeout= 5)
    s.send(message.encode())
    time.sleep(0.5)
    if reply:
        response= s.recv(4096).decode()
        print("response:", response)
        s.close()
        return response
    else:
        s.close()
        return

def measure():
    send_message("init", False)
    
def channel_string(card, channels):
    global totalChannels
    cn = "(@"
    for i in range(len(channels)):
        cn = cn+ str(card)
        cn = cn + str(channels[i]).rjust(2, "0")
        if i == len(channels) - 1:
            cn = cn + ")"
        else:
            cn = cn + ","
        totalChannels = totalChannels + 1
#    print(cn)
    return cn
    
cards= {}
#        1: "(@101:110)",
#        2: "(@201:210)"
#        }
        
def build_channel_names(cards_t):
    for card_var in range(len(cards_t)):
        cardNo = card_var + 1
#        print("cardNo:", cardNo)
        cards[cardNo] = channel_string(cardNo, cards_t[card_var])
    return

DAQ_hostname= "i75450"
DAQ_port= 5025
card1= [1,2,3,4,5,6,7,8,9,10]
card2= [1,2,3,4,5,6,7,8,9,10]
card3= []

cardOrder = [1,2]

build_channel_names([card1, card2])
print("cards:", cards)

config_steps = {
                "function": ":func 'temp', ",
                "fourwire": ":sens:temp:tran frtd, ",
                "PT100": ":sens:temp:rtd:four pt100, ",
                "scan_create": ":route:scan:create ",
                "scan_add": ":route:scan:add "
                }
                
def prepare(steps):
    for step in steps:
        for cardNo in cardOrder:
            message = config_steps[step] + cards[cardNo]
            send_message(message, False)
    
def prepare_scan():
    i = 0
    for cardNo in cardOrder:
        if i == 0:
            message = config_steps["scan_create"] + cards[cardNo]
        else:
            message = config_steps["scan_add"] + cards[cardNo]
        i += 1
        send_message(message, False)
    
def readout():
    message = "trac:data? 1," + str(totalChannels)
#    print(message)
    send_message(message, True)
    
def test():
    message = ":ROUTe:SCAN:STATe?"
    send_message(message, True)

reset()
prepare(["function", "fourwire", "PT100"])
prepare_scan()
#test()
measure()
time.sleep(5)
readout()

