# -*- coding: utf-8 -*-
"""
@author: friske01
"""
import sys
import numpy as np
import couchdb 
import pandas as pd
import json
import csv
import re
from pprint import pprint
import matplotlib
import PyQt5
from matplotlib import pyplot as plt
matplotlib.use('Qt5Agg')
import pathlib

try:
    from configparser import ConfigParser
except ImportError:
    from ConfigParser import ConfigParser  # ver. < 3.0


configtl = ConfigParser()
ini_values = ConfigParser()
# parse existing file
configtl.read('tl.ini')
ini_values.read('inputs.ini')

server=configtl.get('couch', 'couch')
db_vl=configtl.get('couch', 'db')

couch = couchdb.Server(server)
db = couch[db_vl]

#dataSets = [[75588, 3, 2024]]
#dataSets = [[75588, 1, 2024]]
#dataSets = [[75588, 5, 2024]]
dataSets = [[75653, 1, 2024]]

data = {}

for i in range(len(dataSets)):
    identifier = str(dataSets[i][0]) + "_" + str(dataSets[i][1]).zfill(4)
    dbString = "cal-" + str(dataSets[i][2]) + "-tl2-kk-" + identifier
    print(dbString)
    data[identifier] = db.get(dbString)
#    pprint(data)

#json_file = "cal-" + year + "-fm1-kk-" + cal_cert + "_" + no
#doc = db.get(json_file) 
#print(json_file)

SZ_raw = {}
SZ_slopes = {}
drift = {}
drift_result = {}
fig, axs = plt.subplots(ncols=2, nrows=3, figsize=(3.5, 2.5), layout="constrained")

for files in data.keys():
    for SZ in ["SZ1", "SZ2"]:
        p = None
        t = None
        if (data[files]["Calibration"]["Measurement"]["AuxValues"][SZ][0]["Type"] == "p-sz1" or data[files]["Calibration"]["Measurement"]["AuxValues"][SZ][0]["Type"] == "p-sz2"):
            p = 0
            t = 1
        else:
            p = 1
            t = 0
        for i in range(len(data[files]["Calibration"]["Measurement"]["AuxValues"][SZ][p]["Value"])):
            SZ_raw[(files, i, SZ)] = [data[files]["Calibration"]["Measurement"]["AuxValues"][SZ][t]["Value"][i], data[files]["Calibration"]["Measurement"]["AuxValues"][SZ][p]["Value"][i]]

    for D in ["D1", "D2"]:
        p = None
        t = None
        if (data[files]["Calibration"]["Measurement"]["AuxValues"][D][0]["Type"] == "p-d1" or data[files]["Calibration"]["Measurement"]["AuxValues"][D][0]["Type"] == "p-d2"):
            p = 0
            t = 1
        else:
            p = 1
            t = 0
        for i in range(len(data[files]["Calibration"]["Measurement"]["AuxValues"][D][p]["Value"])):
            drift[(files, i, D)] = [data[files]["Calibration"]["Measurement"]["AuxValues"][D][t]["Value"][i], data[files]["Calibration"]["Measurement"]["AuxValues"][D][p]["Value"][i]]
    axs[2,0].plot(range(len(data[files]["Calibration"]["Measurement"]["Values"]["Pressure"][0]["Value"])), data[files]["Calibration"]["Measurement"]["Values"]["Pressure"][0]["Value"], 'bo')
    axs[2,0].set_title("Außendruck")
    axs[2,1].plot(range(len(data[files]["Calibration"]["Measurement"]["AuxValues"]["dp_dt"][2]["Value"])), data[files]["Calibration"]["Measurement"]["AuxValues"]["dp_dt"][2]["Value"], 'bo')
    axs[2,1].plot(range(len(data[files]["Calibration"]["Measurement"]["AuxValues"]["dp_dt"][3]["Value"])), data[files]["Calibration"]["Measurement"]["AuxValues"]["dp_dt"][3]["Value"], 'go')
    axs[2,1].set_title("Drift, einzeln")
#print(drift.keys())
#print(SZ_raw.keys())
#print(SZ_raw[('75588_0002', 0, 'SZ2')])

for item in SZ_raw.keys():
    data = {"x": np.array(SZ_raw[item][0]), "y": np.array(SZ_raw[item][1])}
    print(data)
    data["y"] = data["y"][data["x"] > 0]
    data["x"] = data["x"][data["x"] > 0]
    #data["y"] = data["y"] - data["y"][-1]
    #data["x"] = data["x"] - data["x"][0]
    SZ_slopes[item] = np.polyfit(data["x"], data["y"], 1)[0]
    drift_result[(item[0], item[1])] = (np.polyfit(drift[(item[0], item[1], "D1")][0], drift[(item[0], item[1], "D1")][1], 1)[0] + np.polyfit(drift[(item[0], item[1], "D2")][0], drift[(item[0], item[1], "D2")][1], 1)[0]) / 2
    if (item[2] == "SZ1"):
    #if True:
        axs[0,0].plot(data["x"], data["y"])
        axs[0,0].set_title("SZ1")
        #axs[2,1].plot(item[1], data["y"][0], "bo")
    else:
        axs[0,1].plot(data["x"], data["y"])
        axs[0,1].set_title("SZ2")
        #axs[2,1].plot(item[1], data["y"][0], "go")
    #axs[2,1].plot(data["x"], data["y"])
print(drift_result)
#for item in drift.keys():
#    axs[0,1].plot(np.array(drift[item][0]), np.array(drift[item][1]) - drift[item][1][0])
#plt.show()
for item in SZ_raw.keys():
    dot = ""
    dot_d = ""
    if item[2] == "SZ1":
        dot = "bo"
        dot_d = "bx"
    else:
        dot = "go"
        dot_d = "gx"
    axs[1,0].plot(item[1], SZ_slopes[item], dot)
    axs[1,0].plot(item[1], SZ_slopes[item] - drift_result[(item[0], item[1])], dot_d)
    axs[1,0].set_title("Steigungen mit/ohne Drift")
    axs[1,1].plot(item[1], drift_result[(item[0], item[1])], 'ro')
    axs[1,1].set_title("Drift")
    #axs[2,1].plot(
plt.show()
