# -*- coding: utf-8 -*-
"""
Created on Fri Jan  6 11:14:44 2023

@author: becker07
"""

from pathlib import Path
import os
import couchdb
import argparse
import json
try:
    from configparser import ConfigParser
except ImportError:
    from ConfigParser import ConfigParser  # ver. < 3.0


configtl1 = ConfigParser()
ini_values = ConfigParser()
# parse existing file
configtl1.read('tl.ini')
#print(configtl1.sections())
#print(configtl1)
ini_values.read('inputs.ini')
# read values from a section

cal_cert = ini_values.get('input_cer', 'cal_cert')
year = ini_values.get('input_gen',  'year')
year_str2=year[2:]
no = ini_values.get('input_gen', 'no')
path=Path(configtl1.get('path', 'path'))
server=configtl1.get('couch', 'couch')
db_vl=configtl1.get('couch', 'db')

couch = couchdb.Server(server)
db = couch[db_vl] # existing

RefNo = ini_values.get('bur', 'RefNo')   

RefNo='bur-7.5-1V-' + year_str2 + '-' + RefNo  



print(RefNo)

doc_RefNo = db.get(RefNo)

cers =doc_RefNo["Bureaucracy"]["Certificate"]
print(cers)



#cers = ["75552","75553"]    #  Beispiel: cers = ["75511_0001","75512_0001"] 
#cers = ["75562","75563"]    #  Beispiel: cers = ["75511_0001","75512_0001"] 
#config_file = "config.json"
#with open(config_file) as fp:
#	config = json.load(fp)
#
#cmd_parser = argparse.ArgumentParser(description= "Schreibt erstellen kalibrierschein (TeX und PDF) in die CouchDB")
#cmd_parser.add_argument("cal_no", type= int, metavar= "<Kalibrierschein-Nummer>", nargs= "*")
#cmd_parser.add_argument("-y", "--year", type= int, metavar= "<Messjahr>")
#args = cmd_parser.parse_args()
#
#path= Path(config["Pfad"]["Kalibrierschein"])
#year = str(config["KS-Daten"]["Jahr"])
#
#if args.year is not None:
#	year = str(args.year)
#
#cers = [""] * len(args.cal_no)
##print(args.cal_no)
#
#for pos in range(len(args.cal_no)):
#	cers[pos] = str(args.cal_no[pos])
#print(cers)

#cers = ["75559"]    #  Beispiel: cers = ["75511_0001","75512_0001"] 
#cers = ["75562","75563"]    #  Beispiel: cers = ["75511_0001","75512_0001"] 
#exit()
###################  die Kalibrierscheine werden an das cer-json-dokument angehangen ##################


for cers_i in cers:
    print(cers_i)
    cers_i=str(cers_i) 
    json_file = "cer-" + year + '-' + cers_i
    print(json_file)
    doc = db.get(json_file)
    cer_pdf= "ks-" +cers_i + "-" + year + ".pdf"
    cer_tex= "ks-" +cers_i + "-" + year + ".tex"
    print(cer_pdf, cer_tex)
    ks_pdf = path.joinpath(cer_pdf)
    ks_tex = path.joinpath(cer_tex)
    print(ks_pdf, ks_tex)
    content_pdf=ks_pdf.read_bytes() 
    content_tex=ks_tex.read_bytes() 
    db.put_attachment(doc, content_pdf, cer_pdf , content_type='application/pdf')
    db.put_attachment(doc, content_tex, cer_tex , content_type='text/plain')
        
   
    
   
###################  die Kalibrierscheine werden im Ordner Kalibrierscheine gelöscht ################## 
#exit()
   
for cers_i in cers:
    cers_i=str(cers_i) 
    json_file = "cer-" + year + '-' + cers_i 
    print(json_file)
    doc = db.get(json_file)
    cer_pdf= "ks-" + cers_i + "-" + year + ".pdf"
    cer_tex= "ks-" + cers_i + "-" + year + ".tex"
    cer_aux= "ks-" + cers_i + "-" + year + ".aux"
    cer_log= "ks-" + cers_i + "-" + year + ".log"
    cer_gz= "ks-" + cers_i + "-" + year + ".synctex.gz"
    print(cer_pdf, cer_tex)
    ks_pdf = path.joinpath(cer_pdf)
    ks_tex = path.joinpath(cer_tex)
    ks_aux = path.joinpath(cer_aux)
    ks_log = path.joinpath(cer_log)
    ks_gz = path.joinpath(cer_gz)
    
    print(ks_pdf, ks_tex)
    ks_pdf.unlink(missing_ok= True)
    ks_tex.unlink(missing_ok= True)
    ks_aux.unlink(missing_ok= True)
    ks_log.unlink(missing_ok= True)
    ks_gz.unlink(missing_ok= True)
    
