# -*- coding: utf-8 -*-
"""
Created on Fri Jul  1 12:12:37 2022

@author: becker07
"""

from matplotlib import pyplot as plt
from statistics import mean
from datetime import datetime
from IPython.display import Markdown as md
import numpy as np
import math
import statistics
import pandas as pd
import json
import couchdb
from pathlib import Path
import os
import argparse
from pprint import pprint
#import pathlib
couch = couchdb.Server('http://a73434.berlin.ptb.de:5984')
db = couch['vl_db'] # existing

## Eingabe von:
#    - Kalibrierscheinnummer
#    - Jahr der Kalibrierung 
#    - laufende Nummer der Kalibrierung

config_file = "config.json"
with open(config_file) as fp:
	config = json.load(fp)
#for section in config.keys():
#	print("section:", section)
#	for entry in config[section].keys():
#		print(entry, "=", config[section][entry])

cmd_parser = argparse.ArgumentParser(description= "Verarbeitet Messdaten aus TLA und speichert sie als CouchDB-Dokument")
cmd_parser.add_argument("cal_no", type= int, metavar= "<Kalibrierschein-Nummer>")
cmd_parser.add_argument("-y", "--year", type= int, metavar= "<Messjahr>")
cmd_parser.add_argument("-n", "--number", type= int, metavar= "<laufende Nummer>")
args = cmd_parser.parse_args()

#cal_cert = "75559"
year = str(config["KS-Daten"]["Jahr"])
no = str(config["KS-Daten"]["lfd. Nr."]).zfill(4)

#if args.cal_no is not None:
cal_cert = str(args.cal_no)
if args.year is not None:
	year = str(args.year)
if args.number is not None:
	no = str(args.number).zfill(4)

#print("year:", year)
#print("no:", no)

json_file = "cal-" + year + "-tl2-kk-" + cal_cert + "_" + no
doc = db.get(json_file) 

# Die Daten aus dem File mit der entsprechenden Kalibrierscheinnummer werden eingelesen:
# datum, time, p_up und alle Temperaturen, 
path=Path(config["Pfad"]["Messwerte"])

#print(path.exists())
#datei = path.joinpath(year + ".json")
datei = path.joinpath(cal_cert + "_" + no + "PTB" + year)
#datei = "file://fs.isc.pad.ptb.de/fs/Abt7/Fb75/Vakuum/Messplaetze/TL2/Messwerte/75556PTB2024"
#print(datei, datei.exists(), datei.stat())
datei_S = path.joinpath(cal_cert + "_" + no + "PTB" + year + "_S")
print(json_file)

#exit()

#with smbclient.open_file(datei, mode= 'r') as datei_handle:
datei_pkt = pd.read_csv(datei,  sep="\t", decimal = ',' )
#print(datei_pkt)
#with smbclient.open_file(datei_S, mode= 'r') as datei_handle:
datei_S_pkt = pd.read_csv(datei_S,  sep="\t", decimal = ',' )
#print(datei_S_pkt)
#exit()
datum=datei_pkt["Datum"]
time=datei_pkt["Zeit"]
p_up=datei_pkt["Druck"]

p_up=np.array(p_up)
p_up = np.asarray(p_up, dtype=float)

q_tab=datei_pkt["q_mol"]
T_room=datei_pkt["Raumtemperatur"]
T_h2o=datei_pkt["T-H2O"]
T_wv=datei_pkt["T-WV"]
T_tl=datei_pkt["T-TL"]
T_rv=datei_pkt["T-RV"]
p_atm=datei_pkt["Umgebungsdruck p_0"]*100 # Umrechnung in Pa
d= datei_pkt["d"]
#print(d)

m1_drift = datei_pkt["m1_D"]
m2_drift = datei_pkt["m2_D"]
#print(p_atm)
# Die Werte der Sägezähne befinden sich im File "Kalibrierscheinnummer_S".
# Da pro Messpunkt 2 Sägezähne gefahren werden, existieren auch für jeden Messpunkt 
# jeweils zwei Zeiten t_i und zwei Hübe l_1

l_1=datei_S_pkt["pos1_i"]
l_2=datei_S_pkt["pos2_i"]
l_pos= l_1-l_2
l_i=datei_S_pkt["h_i"]
t_i=datei_S_pkt["t_i"]
m_sz_i =datei_S_pkt["m_i"]


# Im File Datei_S sind die einzelnen Hübe l_i der Nadel in einer Spalte gespeichert, der Hub l 
# muss daher in Hub l_1 und l_2 aufgegliedert werden, da in der Regel 2 Sägezähne gefahren werden.  
l_1=l_pos[0::2]  # Begonnen wird in der Spalte beim Element 0 bis zum Ende der Spalte in zweier Schritte
l_2=l_pos[1::2]   # Begonnen wird in der Spalte beim Element 1 bis zum Ende der Spalte in zweier Schritte


#l_1=np.genfromtxt(datei_S,skip_header=1,usecols=(2)) #### wenn nur 1 SZ vorhanden



# Das gleiche gilt für die Zeit t_i 
t_1=t_i[0::2]   # Begonnen wird in der Spalte beim Element 0 bis zum Ende der Spalte in zweier Schritte
t_2=t_i[1::2]   # Begonnen wird in der Spalte beim Element 1 bis zum Ende der Spalte in zweier Schritte
#t_1=np.genfromtxt(datei_S,skip_header=1,usecols=(3))#### wenn nur 1 SZ vorhanden


# Das gleiche gilt für den SZ m_sz__i 
m_sz_1=m_sz_i[0::2]   # Begonnen wird in der Spalte beim Element 0 bis zum Ende der Spalte in zweier Schritte
m_sz_2=m_sz_i[1::2]   # Begonnen wird in der Spalte beim Element 1 bis zum Ende der Spalte in zweier Schritte

# Temperatur
lis_T_h2o = T_h2o.tolist()
#print("lis_T_h2o:", lis_T_h2o)
lis_T_room = T_room.tolist()
lis_T_tl = T_tl.tolist()
lis_T_wv = T_wv.tolist()
lis_T_rv = T_rv.tolist()
# Druck
lis_p_atm = p_atm.tolist()
lis_p_up = p_up.tolist()
# Drift
lis_m1_drift = m1_drift.tolist()
lis_m2_drift = m2_drift.tolist()
lis_m1_sz = m_sz_1.tolist()
lis_m2_sz = m_sz_2.tolist()
# Datum
lis_date = datum.tolist()
lis_dtime = time.tolist()

lis_l1 = l_1.tolist()
lis_l2 = l_2.tolist()
lis_t1 = t_1.tolist()
lis_t2 = t_2.tolist()
lis_d = d.tolist()

#print(lis_l1 ,lis_l2 ,lis_t1 ,lis_t2)

datum_meas = lis_date[0:1]


#print("lis_T_room:", lis_T_room)

dict = {"Temperature": [{"Unit": "C","Type": "T-H2O","Comment":"Temperatur T","Value": lis_T_h2o},
                                                             {"Unit": "C","Type": "T-Room","Comment":"Temperatur T","Value": lis_T_room},
                                                             {"Unit": "C","Type": "T-TL","Comment":"Temperatur T","Value": lis_T_tl},
                                                             {"Unit": "C","Type": "T-WV","Comment":"Temperatur T","Value": lis_T_wv},
                                                             {"Unit": "C","Type": "T-RV","Comment":"Temperatur T","Value": lis_T_rv}],
                                             "Pressure": [{"Unit": "Pa","Type": "Atmosparic pressure","Value": lis_p_atm},
                                                          {"Unit": "bar","Type": "Upstream pressure","Value": lis_p_up}],
                                             "Time": [{"Unit": "s","Type": "Zeit des ersten Saegezahns","Value": lis_t1},
                                                      {"Unit": "s","Type": "Zeit des zweiten Saegezahns","Value": lis_t2}],
                                             "L": [{"Unit": "mm","Type": "Hub des ersten Saegezahns","Value": lis_l1},
                                                  {"Unit": "mm","Type": "Hub des zweiten Saegezahns","Value": lis_l2}],
												"D": [{"Unit": "mm","Type": "nomineller Nadeldurchmesser","Value": lis_d}],
                                            "Drift": [{"Unit": "Pa/s","Type": "Steigung des ersten Saegezahns","Value": lis_m1_sz},
                                                      {"Unit": "Pa/s","Type": "Steigung des zweiten Saegezahns","Value": lis_m2_sz},
                                                       {"Unit": "Pa/s","Type": "Drift des ersten Saegezahns","Value": lis_m1_drift}, 
                                                      {"Unit": "Pa/s","Type": "Drift des zweiten Saegezahns","Value": lis_m2_drift}],
                                            "DateTime": [{"Unit": "yyyy-mm-dd","Type": "Date","Value": lis_date},
                                                        {"Unit": "hh:mm","Type": "Time ","Value": lis_dtime}]}
pprint(dict)

doc["Calibration"]["Measurement"]["Values"]= dict



doc["Calibration"]["Measurement"]["Date"]=[{"Type": "measurement","Value":datum_meas}]


db.save(doc)


