# -*- coding: utf-8 -*-
"""
Created on Fri Jul  1 12:12:37 2022

@author: becker07
"""

from matplotlib import pyplot as plt
from statistics import mean
from datetime import datetime
from IPython.display import Markdown as md
import numpy as np
import math
import statistics
import pandas as pd
import json
import couchdb 
couch = couchdb.Server('http://a73434.berlin.ptb.de:5984')
db = couch['vl_db'] # existing


## Eingabe von:
#    - Kalibrierscheinnummer
#    - Jahr der Kalibrierung 
#    - laufende Nummer der Kalibrierung



cal_cert = "75575"
year = "2024"
no = "0001"


json_file = "cal-" + year + "-tl2-kk-" + cal_cert + "_" + no
doc = db.get(json_file) 

# Die Daten aus dem File mit der entsprechenden Kalibrierscheinnummer werden eingelesen:
# datum, time, p_up und alle Temperaturen, 
path='N:\\Abt_7\\Fb75\\Vakuum\\Messplaetze\\TL2\\Messwerte\\'
path='/home/friske01/N/Abt_7/Fb75/Vakuum/Messplaetze/TL2/Messwerte/'
datei = path + cal_cert + '_'+ no + "PTB" + year 
datei_S = path +  cal_cert + '_'+ no +"PTB" + year + "_S"
print(json_file)

datei_pkt = pd.read_csv(datei,  sep="\t", decimal = ',' )
datei_S_pkt = pd.read_csv(datei_S,  sep="\t", decimal = ',' )


df = pd.read_csv(datei_S,  sep="\t", decimal = ',' )
df.to_csv('out.csv', index=False)

df = pd.read_csv('out.csv')
time_sz=df["Zeit"]


l = len(df)
time_n = time_sz[l-2]
print(time_n)

i=0

while i < l-1 :
    
    print(time_sz[i])
    time=[time_sz[i]]
    
    if time_sz[i] == time_sz[i+1]:
        i=i+2
    else:
        print('nur eine zeile', i)
        zeile = df.loc[[i]]
        df1 = df.loc [0:i, ] 
        df3 = df.loc [i+1:, ] 
        dfx= pd.concat([df1,zeile], axis=0)
        df= pd.concat([dfx,df3], axis=0)
        df.to_csv('out.csv', index=False)
        print(i)
        if time_sz[i] == time_n:
            i=l
        else:
            l=l+2
            i=i+1
        print(i,l)
            
df = pd.read_csv('out.csv')
time_sz=df["Zeit"]
l = len(df)
time1 = time_sz[l-1]

time2 = time_sz[l-2]
print(time2)

print(time1,time2)   

if time1 == time2:
    print('ende')   
else:
    zeile = df.loc[[l-1]]
    print(zeile)
    df= pd.concat([df,zeile], axis=0)
    df.to_csv('out.csv', index=False)


l = df['h_i']
t = df['t_i']
m_sz_i = df['m_i']


  

l_1 = l[0:len(l):2] # Jede zweite Zeile im Bereich 0 bis n wählen.
l_2 = l[1:len(l):2] # Jede zweite Zeile im Bereich 1 bis n wählen.

t_1 = t[0:len(t):2] # Jede zweite Zeile im Bereich 0 bis n wählen.
t_2 = t[1:len(t):2] # Jede zweite Zeile im Bereich 1 bis n wählen.

m_sz_1 = m_sz_i[0:len(m_sz_i):2] # Jede zweite Zeile im Bereich 0 bis n wählen.
m_sz_2 = m_sz_i[1:len(m_sz_i):2] # Jede zweite Zeile im Bereich 1 bis n wählen.

datum=datei_pkt["Datum"]
time=datei_pkt["Zeit"]
time_sz=datei_pkt["Zeit"]




p_up=datei_pkt["Druck"]
D=datei_pkt["d"]
#sh=datei_pkt["sh "]

p_up=np.array(p_up)
p_up = np.asarray(p_up, dtype=float)

q_tab=datei_pkt["q_mol"]
T_room=datei_pkt["Raumtemperatur"]
T_h2o=datei_pkt["T-H2O"]
T_wv=datei_pkt["T-WV"]
T_tl=datei_pkt["T-TL"]
T_rv=datei_pkt["T-RV"]
p_atm=datei_pkt["Umgebungsdruck p_0"]*100 # Umrechnung in Pa

# Die Werte der Sägezähne befinden sich im File "Kalibrierscheinnummer_S".
# Da pro Messpunkt 2 Sägezähne gefahren werden, existieren auch für jeden Messpunkt 
# jeweils zwei Zeiten t_i und zwei Hübe l_1


m1_drift = datei_pkt["m1_D"]
m2_drift = datei_pkt["m2_D"]
# Im File Datei_S sind die einzelnen Hübe l_i der Nadel in einer Spalte gespeichert, der Hub l 
# muss daher in Hub l_1 und l_2 aufgegliedert werden, da in der Regel 2 Sägezähne gefahren werden.  


# Temperatur
lis_T_h2o = T_h2o.tolist()
lis_T_room = T_room.tolist()
lis_T_tl = T_tl.tolist()
lis_T_wv = T_wv.tolist()
lis_T_rv = T_rv.tolist()
# Druck
lis_p_atm = p_atm.tolist()
lis_p_up = p_up.tolist()
# Drift
lis_m1_drift = m1_drift.tolist()
lis_m2_drift = m2_drift.tolist()
lis_m1_sz = m_sz_1.tolist()
lis_m2_sz = m_sz_2.tolist()
# Datum
lis_date = datum.tolist()
lis_dtime = time.tolist()

lis_l1 = l_1.tolist()
lis_l2 = l_2.tolist()
lis_t1 = t_1.tolist()
lis_t2 = t_2.tolist()

lis_d = D.tolist()
#lis_sh = sh.tolist()

print(lis_l1 ,lis_l2 ,lis_t1 ,lis_t2 )

datum_meas = lis_date[0:1]


print(lis_T_room)



doc["Calibration"]["Measurement"]["Values"]={"Temperature": [{"Unit": "C","Type": "T-H2O","Comment":"Temperatur T ","Value": lis_T_h2o},
                                                             {"Unit": "C","Type": "T-Room","Comment":"Temperatur T","Value": lis_T_room},
                                                             {"Unit": "C","Type": "T-TL","Comment":"Temperatur T","Value": lis_T_tl},
                                                             {"Unit": "C","Type": "T-WV","Comment":"Temperatur T","Value": lis_T_wv},
                                                             {"Unit": "C","Type": "T-RV","Comment":"Temperatur T","Value": lis_T_rv}],
                                             "Pressure": [{"Unit": "Pa","Type": "Atmosparic pressure","Value": lis_p_atm},
                                                          {"Unit": "bar","Type": "Upstream pressure","Value": lis_p_up}],
                                             "Time": [{"Unit": "s","Type": "Zeit des ersten Saegezahns","Value": lis_t1},
                                                      {"Unit": "s","Type": "Zeit des zweiten Saegezahns","Value": lis_t2}],
                                             "L": [{"Unit": "mm","Type": "Hub des ersten Saegezahns","Value": lis_l1},
                                                  {"Unit": "mm","Type": "Hub des zweiten Saegezahns","Value": lis_l2}],
                                             "D": [{"Unit": "mm","Type": "nomineller Nadeldurchmesser","Value": lis_d}],
                                             #"SH": [{"Unit": "1","Type": "Anzahl SZ","Value": lis_sh}],
                                            "Drift": [{"Unit": "Pa/s","Type": "Steigung des ersten Saegezahns","Value": lis_m1_sz},
                                                      {"Unit": "Pa/s","Type": "Steigung des zweiten Saegezahns","Value": lis_m2_sz},
                                                       {"Unit": "Pa/s","Type": "Drift des ersten Saegezahns","Value": lis_m1_drift}, 
                                                      {"Unit": "Pa/s","Type": "Drift des zweiten Saegezahns","Value": lis_m2_drift}],
                                            "DateTime": [{"Unit": "yyyy-mm-dd","Type": "Date","Value": lis_date},
                                                        {"Unit": "hh:mm","Type": "Time ","Value": lis_dtime}]}



doc["Calibration"]["Measurement"]["Date"]=[{"Type": "measurement","Value":datum_meas}]


db.save(doc)


