# -*- coding: utf-8 -*-
"""
Created on Fri Jul  1 12:12:37 2022

@author: becker07
"""
import sys
import numpy as np
import couchdb 
import pandas as pd
import json
import csv
import re
from matplotlib import pyplot as plt
import pathlib

try:
    from configparser import ConfigParser
except ImportError:
    from ConfigParser import ConfigParser  # ver. < 3.0


configtl = ConfigParser()
ini_values = ConfigParser()
# parse existing file
configtl.read('tl.ini')
ini_values.read('inputs.ini')

server=configtl.get('couch', 'couch')
db_vl=configtl.get('couch', 'db')

couch = couchdb.Server(server)
db = couch[db_vl] # existing


## Eingabe von:
#    - Kalibrierscheinnummer
#    - Jahr der Kalibrierung 
#    - laufende Nummer der Kalibrierung

path=configtl.get('path', 'path_files')



cal_cert = ini_values.get('input_cer', 'cal_cert')
year = ini_values.get('input_gen', 'year')
no = ini_values.get('input_gen', 'no')
QMS="ja"   ######### ja beim Scan
kk_ik_pn= "kk" ######## kk,ik oder pn



json_file = "cal-" + year + "-fm1-ik-" + cal_cert + "_" + no
doc = db.get(json_file) 
print(json_file)

#path='C:\\Users\\becker07\\python\\TL1\\'

dateiTab =  path + cal_cert + "_" + no
#dateiTab='C:\\Users\\becker07\\python\\TL1\\75561'
print(dateiTab)


dateiTab=pd.read_csv(dateiTab,  sep="\t", decimal = ',' )

L_ar=dateiTab["C "]
print('Leitwert j= 1, nein = 0 :: ', L_ar)

L=L_ar[0]
print('Leitwert : ',L)


#gauge = float(doc["Calibration"]["CustomerObject"]["Setup"]["CDG"])
gauge = 10
print(gauge)

# Die Daten aus dem File mit der entsprechenden Kalibrierscheinnummer werden eingelesen:
# datum, time, p_up und alle Temperaturen, 


#datei = "N:\Abt_7\Fb75\Vakuum\Messplaetze\TL1\Kalibrierungen\\22\\TP7464.txt"

if True:
    
    
    m1=dateiTab["m1"]
    m2=dateiTab["m2"]
    m3=dateiTab["m3"]
    m4=dateiTab["m4"]

    t1=dateiTab["t1"]
    t2=dateiTab["t2"]
    t3=dateiTab["t3"]
    t4=dateiTab["t4"]
    time1=dateiTab["time1"]
    time2=dateiTab["time2"]
    time3=dateiTab["time3"]

    pmean=dateiTab["p-mean"]*100
    pmin=dateiTab["p-min"]*100
    pmax=dateiTab["p-max"]*100
    

    h=dateiTab["distance"]
    
       
    print("Constantes Volumen",h)
    
                               
                                                                
else:
    print("Constanter Leitwert")


datum=dateiTab["Datum"]
time=dateiTab["Zeit"]
gas=dateiTab["Gasart"]

if gauge== 0.01 :
    p_offs_01=dateiTab["p-offset"]*100
    p_fill_01=dateiTab["p-fill "]*100
    p_fill_srg=dateiTab["p-max"]
    p_offs_srg=dateiTab["p-min"]
    
else :
    p_offs=dateiTab["p-offset"]*100
    p_fill=dateiTab["p-fill "]*100
#p_fill=np.genfromtxt(dateiTab,skip_header=1,delimiter='\t',usecols=(5))

p_ig=dateiTab["Kommentar"]
T_room=dateiTab["T-Raum"]
T_fm=dateiTab["T-FM"]
T_tl1=dateiTab["T-TL1"]
T_tl2=dateiTab["T-TL2"]
T_tl3=dateiTab["T-TL3"]
T_tl4=dateiTab["T-TL4"]

#print(T_fm,T_room,T_tl1, T_tl2,T_tl3,T_tl4)


# Temperatur
lis_T_fm = T_fm.tolist()
lis_T_room = T_room.tolist()
lis_T_tl1 = T_tl1.tolist()
lis_T_tl2 = T_tl2.tolist()
lis_T_tl3 = T_tl3.tolist()
lis_T_tl4 = T_tl4.tolist()


# Druck

if gauge == 0.01 :
    lis_p_offs_01 = p_offs_01.tolist()
    lis_p_fill_01 = p_fill_01.tolist()
    lis_p_offs_srg = p_offs_srg.tolist()
    lis_p_fill_srg = p_fill_srg.tolist()
    
    
    
else:
    lis_p_offs = p_offs.tolist()
    lis_p_fill = p_fill.tolist()
    


lis_p_ig = p_ig.tolist()
# Datum
# Datum
lis_datum = datum.tolist()
lis_time = time.tolist()


datum_meas = lis_datum[0:1]




if True:
    #Leitwert
    lis_c = L_ar.tolist()

    # Steigung SZ
    lis_m1 = m1.tolist()
    lis_m2 = m2.tolist()
    lis_m3 = m3.tolist()
    lis_m4 = m4.tolist()

    # Zeitpunkte
    lis_t1 = t1.tolist()
    lis_t2 = t2.tolist()
    lis_t3 = t3.tolist()
    lis_t4 = t4.tolist()

    # Zeit pro SZ
    lis_time1 = time1.tolist()
    lis_time2 = time2.tolist()
    lis_time3 = time3.tolist()

    # Druck der SZ
    lis_pmean = pmean.tolist()
    lis_pmin = pmin.tolist()
    lis_pmax= pmax.tolist()

    # Druck der SZ
    lis_h = h.tolist()
    
    
    doc["Calibration"]["Measurement"]["Values"]={"Temperature": [{"Unit": "C","Type": "T-FM","Comment":"Temperatur T ","Value": lis_T_fm},
                                                                {"Unit": "C","Type": "T-Room","Comment":"Temperatur T","Value": lis_T_room},
                                                                {"Unit": "C","Type": "T-TL1","Comment":"Temperatur T","Value": lis_T_tl1},
                                                               {"Unit": "C","Type": "T-TL2","Comment":"Temperatur T","Value":lis_T_tl2},
                                                               {"Unit": "C","Type": "T-TL2","Comment":"Temperatur T","Value":lis_T_tl3},
                                                               {"Unit": "C","Type": "T-TL3","Comment":"Temperatur T","Value": lis_T_tl4}],
                                                "Pressure": [{"Unit": "Pa","Type": "Offset pressure","Value":lis_p_offs},
                                                             {"Unit": "Pa","Type": "pressure mean","Value":lis_p_fill}],
                                                "Date": [{"Unit": "year-month-day","Type": "Datum","Value":lis_datum},
                                                             {"Unit": "hh:mm:ss","Type": "Messzeit","Value":lis_time}]
												}
#    print(doc["Calibration"]["Measurement"]["Values"])



    doc["Calibration"]["Measurement"]["Date"]=[{"Type": "measurement","Value": datum_meas}]

    doc["Calibration"]["Measurement"]["Values"]["Conductance"]={"t": [{"Unit": "s","Type": "t1","Comment":"Zeitpunkt t1 des 1.SZ","Value": lis_t1},
                                                                            {"Unit": "s","Type": "t2","Comment":"Zeitpunkt t2 des 2.SZ","Value": lis_t2}, 
                                                                            {"Unit": "s","Type": "t3","Comment":"Zeitpunkt t3 des 3.SZ","Value": lis_t3},
                                                                           {"Unit": "s","Type": "t4","Comment":"Zeitpunkt t4 des 4.SZ","Value": lis_t4}],
                                                                "time": [{"Unit": "s","Type": "time1","Comment":"Zeit t2-t1 von SZ","Value": lis_time1},
                                                                       {"Unit": "s","Type": "time2","Comment":"Zeit t3-t2 von SZ","Value": lis_time2}, 
                                                                      {"Unit": "s","Type": "time3","Comment":"Zeit t4-t3 von SZ","Value": lis_time3}],
                                                                "m": [{"Unit": "Pa/s","Type": "m1","Comment":"Steigung m1 des 1.SZ","Value": lis_m1},
                                                                       {"Unit": "Pa/s","Type": "m2","Comment":"Steigung m1 des 2.SZ","Value": lis_m2}, 
                                                                      {"Unit": "Pa/s","Type": "m3","Comment":"Steigung m1 des 3.SZ","Value": lis_m3},
                                                                       {"Unit": "Pa/s","Type": "m3","Comment":"Steigung m1 des 4.SZ","Value": lis_m3}],
                                                               "pressure": [{"Unit": "Pa","Type": "pmean","Comment":"Mittelwert von p","Value": lis_pmean},
                                                                      {"Unit": "Pa","Type": "pmin","Comment":"p_min des SZ","Value": lis_pmin}, 
                                                                      {"Unit": "Pa","Type": "pmax","Comment":"p_max des SZ","Value": lis_pmax}],
                                                               "l": [{"Unit": "mm","Type": "l","Comment":"Hub des Verdrängers","Value": lis_h}],
                                                               "C": [{"Unit": "m^3/s","Type": "Constanter Leitwert ","Value": lis_c}]
                                                               
                                                                }



    
    
    print("Constantes Volumen")
    
                               
                                                                

    
    
#doc["Calibration"]["Measurement"]["Date"]=[{"Type": "measurement","Value": datum_meas}]


db.save(doc)



